// R_REM.CPP : Remote f. Radio
// G. TAMM, DF9ZO 2007
//--------------------
#ifndef _R_REM_H_
  #include "R_REM.H"
#endif
//Globals++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RemDlg*    remdlg=0;
RemExtDlg* remextdlg=0;
RemDisp*   remdisp=0;
RemWin*    remwin=0;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//RemWin+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IMPLEMENT_DYNCREATE(RemWin, CFrameWnd)

RemWin::RemWin() {}

RemWin::RemWin(CFrameWnd* parent,CString& file)
{
 winparent=parent;
 strcpy(finame,LPCTSTR(file));
 LiReadFile(Fli,0,finame);FliMax=Fli.size();
}

RemWin::~RemWin()
{
 LiRemAllElem(Fli);
 remwin=0;
}

BEGIN_MESSAGE_MAP(RemWin, CFrameWnd)
	//{{AFX_MSG_MAP(RemWin)
	ON_WM_HSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	ON_WM_PAINT()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL RemWin::PreCreateWindow(CREATESTRUCT& cs) 
{
 cs.style|=WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL;

 cs.x=Win_XIOpos+2;cs.y=Win_YIOpos+2;  
 cs.cx=250;cs.cy=200;

 ScrX=ScrY=0;ScrXmax=50;ScrPaStep=5;
 SetScrollRange(SB_VERT,0,FliMax-1);
 SetScrollRange(SB_HORZ,0,ScrXmax);
 SetScrollPos(SB_VERT,0);SetScrollPos(SB_HORZ,0);

 return CFrameWnd::PreCreateWindow(cs);
}
//-----------------------------------------------------------------------------
void RemWin::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
 if (FliMax == 0) return; 
 switch (nSBCode) 
  {     
   case SB_LINELEFT     :OnLineLe();break;
   case SB_LINERIGHT    :OnLineRi();break;
   case SB_PAGELEFT     :OnPageLe();break;
   case SB_PAGERIGHT    :OnPageRi();break;
   case SB_THUMBPOSITION: 
   case SB_THUMBTRACK   :ScrX=nPos;UpdateScrBars();break;
  }			
 CFrameWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}

void RemWin::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
 if (FliMax == 0) return; 
 switch (nSBCode) 
  {     
   case SB_LINEUP       :OnLineUp();break;
   case SB_LINEDOWN     :OnLineDo();break;
   case SB_PAGEUP       :OnPageUp();break;
   case SB_PAGEDOWN     :OnPageDo();break;
   case SB_THUMBPOSITION: 
   case SB_THUMBTRACK   :ScrY=nPos;UpdateScrBars();break;
  }				
 CFrameWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

void RemWin::OnLineUp() {ScrY--;UpdateScrBars();}

void RemWin::OnLineDo() {ScrY++;UpdateScrBars();}

void RemWin::OnPageUp() {ScrY-=ScrPaStep;UpdateScrBars();}

void RemWin::OnPageDo() {ScrY+=ScrPaStep;UpdateScrBars();}

void RemWin::OnHome()   {ScrX=ScrY=0;UpdateScrBars();}

void RemWin::OnEnd()    {ScrX=0;ScrY=FliMax-1;UpdateScrBars();}

void RemWin::OnLineLe() {ScrX--;UpdateScrBars();}

void RemWin::OnLineRi() {ScrX++;UpdateScrBars();}

void RemWin::OnPageLe() {ScrX-=ScrPaStep;UpdateScrBars();}

void RemWin::OnPageRi() {ScrX+=ScrPaStep;UpdateScrBars();}

void RemWin::UpdateScrBars()
{
 if (ScrX < 0) ScrX=0;
 if (ScrX > ScrXmax-1) ScrX=ScrXmax;
 if (ScrY < 0) ScrY=0; 
 if (ScrY > FliMax-1)   ScrY=FliMax-1;

 SetScrollRange(SB_VERT,0,FliMax-1);SetScrollRange(SB_HORZ,0,ScrXmax);
 SetScrollPos(SB_VERT,0);SetScrollPos(SB_HORZ,0); 
 SetScrollPos(SB_HORZ,ScrX,TRUE);SetScrollPos(SB_VERT,ScrY,TRUE);
 Invalidate();
}
//-----------------------------------------------------------------------------
void RemWin::OnLButtonDown(UINT nFlags, CPoint point) 
{
 int MouseY;

 if (FliMax == 0) return;
 MouseY=(point.y/SchrH)+(ScrY+1);
 if (MouseY <= FliMax)
  {
   LiGetElemAt(Fli,LineBuf,MouseY);
   winparent->PostMessage(WM_REMWIN_ITEMSELECTION);
  }		
 CFrameWnd::OnLButtonDown(nFlags, point);
}

void RemWin::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
 if (FliMax == 0) return;
 switch (nChar)
  {
   case VK_HOME  :OnHome();  break;
   case VK_END   :OnEnd();   break;
   case VK_NEXT  :OnPageDo();break;
   case VK_DOWN  :OnLineDo();break;
   case VK_PRIOR :OnPageUp();break;
   case VK_UP    :OnLineUp();break;
   case VK_LEFT  :OnLineLe();break;
   case VK_RIGHT :OnLineRi();break;
   case VK_RETURN:OnReturn();break;
   default       :break;
  }	
 CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void RemWin::OnReturn()
{
 if (ScrY <= FliMax-1)
  {
   LiGetElemAt(Fli,LineBuf,ScrY+1);
   winparent->PostMessage(WM_REMWIN_ITEMSELECTION);
  }
}
//-----------------------------------------------------------------------------
void RemWin::OnSize(UINT nType, int cx, int cy) 
{
 CFrameWnd::OnSize(nType, cx, cy);
 Invalidate();		
}

void RemWin::OnPaint() 
{
 CPaintDC   dc(this);
 CFont*     oldfont;
 TEXTMETRIC metric;
 CRect      rect;
 CString    str;
 int        i,x,y,lifrom,lito;
  
 if (FliMax == 0) return; 
 oldfont=(CFont*) dc.SelectStockObject(ANSI_FIXED_FONT);
 GetClientRect(rect);
 dc.GetTextMetrics(&metric);
 SchrH=metric.tmHeight+metric.tmExternalLeading;
 SchrB=metric.tmAveCharWidth+metric.tmOverhang;
 //---------------------------------------------
 x=-(ScrX*SchrB);y=0;
 lifrom=ScrY+1;//Scroller beginnt bei 0
 lito=lifrom+((rect.bottom-rect.top)/SchrH);
 if (lito > FliMax) lito=FliMax;
 //---------------------------------------------
 for (i=lifrom;i<lito+1;i++)
  {
   LiGetElemAt(Fli,str,i);
   if (i == lifrom) dc.SetTextColor(RGB(255,0,0));
      else dc.SetTextColor(RGB(0,0,0));
   dc.TextOut(x,y,str);
   y+=SchrH;
  }
 //---------------------------------------------
 dc.SelectObject(oldfont); 
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//RemDisp++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IMPLEMENT_DYNCREATE(RemDisp, CFrameWnd)

RemDisp::RemDisp() {}

RemDisp::~RemDisp() {}

BEGIN_MESSAGE_MAP(RemDisp, CFrameWnd)
	//{{AFX_MSG_MAP(RemDisp)
    ON_MESSAGE(WM_REMDISP_FREQCHANGED,MsgUpdateFreq)
    ON_MESSAGE(WM_REMDISP_STATUSCHANGED,MsgUpdateStatus)

	ON_WM_LBUTTONDOWN()
	ON_WM_KEYUP()
	ON_WM_KEYDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_PAINT()
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
    ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL RemDisp::PreCreateWindow(CREATESTRUCT& cs) 
{
 SHIFT_DO=0;CTRL_DO=0;

 cs.style|=WS_POPUP | WS_VISIBLE | WS_CAPTION;

 cs.x=Win_XIOpos+2;cs.y=Win_YIOpos+2;  
 Hf=95;Bf=40;
 Hn=16;Bn=10;  
 cs.cx=13*Bf+10;cs.cy=Hf+5*Hn;

 Ffont.CreateFont(Hf,Bf,0,0,FW_BOLD,FALSE,FALSE,0,ANSI_CHARSET,
                  OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
                  DEFAULT_PITCH | FF_MODERN,"Courier New");
 Nfont.CreateFont(Hn,Bn,0,0,FW_MEDIUM,FALSE,FALSE,0,ANSI_CHARSET,
                  OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
                  DEFAULT_PITCH | FF_MODERN,"Arial");
 Brush.CreateSolidBrush(RGB(255,255,255));

 for (int x=0;x < 13;x++) Fold_s[x]=-1;
 PtrToRemDisp=this;
 return CFrameWnd::PreCreateWindow(cs);
}
//-----------------------------------------------------------------------------
void RemDisp::ChFreq(unsigned int step,int up)
{
 float res;

 if (up)
  {
   res=(float)Fact_n+step;
   if ((unsigned int)res > Fmax_n) return;else Fact_n+=step;
  }else
  {
   res=(float)Fact_n-step;
   if ((unsigned int)res < Fmin_n) return;else Fact_n-=step;
  }
 //----------------------------------
 SetActToLast();
 FnumToFstr(Fact_s,Fact_n);
 comport.SetFREQ(Fact_s);remdlg->GetCOMAnswer(IB_OK);
 UpdateFreqDisp();UpdateStatusDisp(1,1,0);
}

unsigned int RemDisp::CalcDispStep(int mx)
{
 // 1295.350,000   Bf=40
 if (CTRL_DO && mx >= 480) return OFact_n;
 if (SHIFT_DO)
  {
   if (mx > 200 && mx < 240) return 5;
   if (mx > 240 && mx < 280) return 6;
   if (mx > 280 && mx < 320) return 7;
   if (mx > 360 && mx < 400) return 9;
   if (mx > 400 && mx < 440) return 10;
   if (mx > 440 && mx < 480) return 11;
   return 0;
  }
 //------------------------------------------
 if (mx < 40)              return 1000000000;
 if (mx >  40 && mx <  80) return 100000000;
 if (mx >  80 && mx < 120) return 10000000;
 if (mx > 120 && mx < 160) return 1000000;
 if (mx > 160 && mx < 200) return 0;
 if (mx > 200 && mx < 240) return 100000;
 if (mx > 240 && mx < 280) return 10000;
 if (mx > 280 && mx < 320) return 1000;
 if (mx > 320 && mx < 360) return 0;
 if (mx > 360 && mx < 400) return 100;
 if (mx > 400 && mx < 440) return 10;
 if (mx > 440 && mx < 480) return 1;
 if (mx > 480) return SFact_n;
 return 0;
}
//-----------------------------------------------------------------------------
void RemDisp::OnPaint() 
{
 CPaintDC dc(this); 

 dc.SetBkMode(TRANSPARENT);
 oldfont=(CFont*)dc.SelectObject(&Ffont);
 dc.SetTextColor(blue);dc.TextOut(0,0,Fact_s,12);
 dc.SetTextColor(magenta);dc.TextOut(12*Bf,0,"",1); // 
 dc.SelectObject(&oldfont);
 strcpy(Fold_s,Fact_s);
 UpdateStatusDisp(1,1,1);
}

LRESULT RemDisp::MsgUpdateFreq(WPARAM wParam,LPARAM lParam)
{
 UpdateFreqDisp();
 return 0L;
}

void RemDisp::UpdateFreqDisp(void)
{
 CClientDC dc(this);
 CRect     rect;
 char      str[2];
 int       i,x;

 oldbrush=(CBrush*)dc.SelectObject(&Brush);
 oldfont=(CFont*)dc.SelectObject(&Ffont);
 dc.SetBkMode(TRANSPARENT);
 dc.SetTextColor(blue);
 str[1]=0;
 for (x=0;x<12;x++)
  {
   if (x==4 || x==8) continue;// . , im String
   if (Fold_s[x] != Fact_s[x])
    {
     i=x*Bf;
     rect.left=i;rect.top=0;rect.right=i+Bf;rect.bottom=Hf; 
     dc.FillRect(rect,&Brush);
     str[0]=Fact_s[x];Fold_s[x]=Fact_s[x];
     dc.TextOut(i,0,str,1);
    }
  }
 dc.SelectObject(&oldfont);
 dc.SelectObject(&oldbrush);
}

LRESULT RemDisp::MsgUpdateStatus(WPARAM wParam,LPARAM lParam)
{
 switch (RemDisp_UPD)
  {
   case 1:UpdateStatusDisp(1,0,0);break;
   case 2:UpdateStatusDisp(0,1,0);break;
   case 3:UpdateStatusDisp(0,0,1);break;
  }
 return 0L;
}

void RemDisp::UpdateStatusDisp(int line1,int line2,int line3)
{
 CClientDC dc(this);
 CString   dstr("",200);
 CRect     rect;
 char      OFFstr[7]="-",ONstr[7]="+";

 oldbrush=(CBrush*)dc.SelectObject(&Brush);
 if (line1)
  {
   strcpy(DispStr1," Mode: ");strcat(DispStr1,Mact_s);
   strcat(DispStr1," Fi: ");strcat(DispStr1,FIact_s);
   strcat(DispStr1,"   ");
   strcat(DispStr1," SQL: ");
   if (SQL_oc == 0) strcat(DispStr1,"C");else strcat(DispStr1,"O");
   strcat(DispStr1,"   ");
   strcat(DispStr1," S-Meter: ");strcat(DispStr1,SMlev_s);
   rect.left=0;rect.top=Hf;rect.right=13*Bf;rect.bottom=Hf+Hn; 
   dc.FillRect(rect,&Brush);
  }
 if (line2)
  {
   strcpy(DispStr2," Fla: ");strcat(DispStr2,Flas_s);
   strcat(DispStr2,"  Fs: ");strcat(DispStr2,SFact_s);
   strcat(DispStr2,"  Fo: ");strcat(DispStr2,OFact_s);
   rect.left=0;rect.top=Hf+Hn;rect.right=13*Bf;rect.bottom=Hf+2*Hn; 
   dc.FillRect(rect,&Brush);
  }
 if (line3)
  {
   strcpy(DispStr3," Ant:");
   if (ANTsw == 0) strcat(DispStr3,"1");else strcat(DispStr3,"2");
   strcat(DispStr3,"  Att:");
   switch (ATTsw)
    {
     case 0:strcat(DispStr3,OFFstr);break;
     case 1:strcat(DispStr3,"1");   break;
     case 2:strcat(DispStr3,"2");   break;
     case 3:strcat(DispStr3,"3");   break;
    }
   strcat(DispStr3,"  PAMP:");
   switch (PAMPsw)
    {
     case 0:strcat(DispStr3,OFFstr);break;
     case 1:strcat(DispStr3,"1");   break;
     case 2:strcat(DispStr3,"2");   break;
    }
   strcat(DispStr3,"  NB:");
   if (NBsw) strcat(DispStr3,ONstr);else strcat(DispStr3,OFFstr);
   strcat(DispStr3,"  NR:");
   if (NRsw) strcat(DispStr3,ONstr);else strcat(DispStr3,OFFstr);
   strcat(DispStr3,"  ANF:");
   if (ANFsw) strcat(DispStr3,ONstr);else strcat(DispStr3,OFFstr);
   rect.left=0;rect.top=Hf+2*Hn;rect.right=13*Bf;rect.bottom=Hf+3*Hn; 
   dc.FillRect(rect,&Brush);
  }
 dc.SelectObject(&oldbrush);
 //-----------------------------------
 dc.SetBkMode(TRANSPARENT);
 oldfont=(CFont*)dc.SelectObject(&Nfont);
 if (line1) {dc.SetTextColor(red);  dstr=DispStr1;dc.TextOut(0,Hf,dstr);}
 if (line2) {dc.SetTextColor(green);dstr=DispStr2;dc.TextOut(0,Hf+Hn,dstr);}
 if (line3) {dc.SetTextColor(black);dstr=DispStr3;dc.TextOut(0,Hf+2*Hn,dstr);}
 dc.SelectObject(&oldfont);
}
//-----------------------------------------------------------------------------
void RemDisp::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{            
 if (nChar == VK_SHIFT)   {SHIFT_DO=1;return;}
 if (nChar == VK_CONTROL) {CTRL_DO=1;return;}
 if (nChar == VK_NEXT)    {ChFreq(OFact_n,0);return;}//F-Offset
 if (nChar == VK_PRIOR)   {ChFreq(OFact_n,1);return;}
 if (nChar == VK_DOWN)    {ChFreq(SFact_n,0);return;}//F-Step
 if (nChar == VK_UP)      {ChFreq(SFact_n,1);return;}
	
 CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void RemDisp::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
 if (nChar==VK_SHIFT)   {SHIFT_DO=0;return;}
 if (nChar==VK_CONTROL) {CTRL_DO=0;return;}
	
 CFrameWnd::OnKeyUp(nChar, nRepCnt, nFlags);
}

void RemDisp::OnLButtonDown(UINT nFlags, CPoint point) 
{
 unsigned int x;
 char     fstr[13];

 if (point.y > Hf) return;
 x=CalcDispStep(point.x);
 if (SHIFT_DO)
  {
   if (x < 1) return;
   strcpy(fstr,Fact_s);fstr[x]='0';
   Fact_s[x]='0';Fact_n=FstrToFnum(Fact_s);
   comport.SetFREQ(Fact_s);remdlg->GetCOMAnswer(IB_OK);
   UpdateFreqDisp();
   return;
  }
 if (Fact_n > x) ChFreq(x,0);
	
 CFrameWnd::OnLButtonDown(nFlags, point); 
}

void RemDisp::OnRButtonDown(UINT nFlags, CPoint point) 
{
 if (point.y > Hf || SHIFT_DO) return;
 ChFreq(CalcDispStep(point.x),1);
	
 CFrameWnd::OnRButtonDown(nFlags, point);
}

BOOL RemDisp::OnMouseWheel(UINT nFlags, short zDelta, CPoint point) 
{
 int direction;

 ScreenToClient(&point);
 if (point.y > Hf || SHIFT_DO) return 0;
 if (zDelta > 0) direction=1;else direction=0;  
 ChFreq(CalcDispStep(point.x),direction);
	
 return CFrameWnd::OnMouseWheel(nFlags, zDelta, point);
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//RemExtDlg++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RemExtDlg::RemExtDlg(CWnd* pParent /*=NULL*/)
	      : CDialog(RemExtDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(RemExtDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void RemExtDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(RemExtDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(RemExtDlg, CDialog)
	//{{AFX_MSG_MAP(RemExtDlg)
	ON_BN_CLICKED(IDC_REMEXT_PAMP,    OnPAMP)
	ON_BN_CLICKED(IDC_REMEXT_ANT,     OnANT)
	ON_BN_CLICKED(IDC_REMEXT_ATT,     OnATT)
	ON_BN_CLICKED(IDC_REMEXT_AGC,     OnAGC)
	ON_BN_CLICKED(IDC_REMEXT_ANF,     OnANF)
	ON_BN_CLICKED(IDC_REMEXT_NB,      OnNB)
	ON_BN_CLICKED(IDC_REMEXT_NR,      OnNR)
    ON_BN_CLICKED(IDC_REMEXT_DUP,     OnDUP)
    ON_BN_CLICKED(IDC_REMEXT_RTTY,    OnRTTY)
    ON_BN_CLICKED(IDC_REMEXT_ASKALL,  OnAskAll)
	ON_BN_CLICKED(IDC_REMEXT_NEUTRAL, OnNeutral)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
    END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL RemExtDlg::OnInitDialog() 
{
 CString str("",50);
 char    tmpstr[10];

 CDialog::OnInitDialog();
 m_hAccel=NULL;
 m_hAccel=LoadAccelerators(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_REMEXTACCEL));
 SetIcon(::LoadIcon(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME)),TRUE);

 itoa(Radio_Num+1,tmpstr,10);
 str="EXTENDED FUNCTIONS (RADIO ";str+=tmpstr;str+=")";
 SetWindowText(str);
 //-----------------------
 NRsw=0;NBsw=0;ANFsw=0;ANTsw=0;ATTsw=0;PAMPsw=0;DUPsw=0;

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_AF);
 pSB->SetScrollRange(0,255);AFlev_n=0;
 comport.AskAF_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(AFlev_n);
    
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_RF);
 pSB->SetScrollRange(0,255);RFlev_n=0;
 comport.AskRF_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(RFlev_n);
 
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_SQL);
 pSB->SetScrollRange(0,255);SMlev_n=0;
 comport.AskSQL_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(SQLlev_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_TXPWR);
 pSB->SetScrollRange(0,255);TXPWR_n=0;
 comport.AskTXPWR();GetCOMAnswer(0x14);
 pSB->SetScrollPos(TXPWR_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_CWSPEED);
 pSB->SetScrollRange(0,255);CWSPEED_n=0;
 comport.AskCWSPEED();GetCOMAnswer(0x14);
 pSB->SetScrollPos(CWSPEED_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NR_LEV);
 pSB->SetScrollRange(0,255);NRlev_n=0;
 comport.AskNR_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(NRlev_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NB_LEV);
 pSB->SetScrollRange(0,255);NBlev_n=0;
 comport.AskNB_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(NBlev_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NB_WID);
 pSB->SetScrollRange(0,255);NBwid_n=0;
 comport.AskNB_wid();GetCOMAnswer(0x1A);
 pSB->SetScrollPos(NBwid_n);
    
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_PBTL);        
 pSB->SetScrollRange(0,255);PBTL_n=128;
 if (Mact_n < 2 && Mact_n > 3)//FM, WFM: Fehlermeldung 
  {
   comport.AskPBTL();GetCOMAnswer(0x14);
  }
 pSB->SetScrollPos(PBTL_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_PBTH);
 pSB->SetScrollRange(0,255);PBTH_n=128;
 if (Mact_n < 2 && Mact_n > 3)//FM, WFM: Fehlermeldung 
  {
   comport.AskPBTH();GetCOMAnswer(0x14);
  }
 pSB->SetScrollPos(PBTH_n);
 //-----------------------
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_AF);
 pSB->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control
}
//-----------------------------------------------------------------------------
BOOL RemExtDlg::PreTranslateMessage(MSG* pMsg) 
{  
 if(!(m_hAccel && ::TranslateAccelerator(m_hWnd, m_hAccel, pMsg)))
   return CDialog::PreTranslateMessage(pMsg);else return TRUE;
	
 return CDialog::PreTranslateMessage(pMsg);
}
//-----------------------------------------------------------------------------
void RemExtDlg::OnOK() 
{
 DestroyWindow();
}

void RemExtDlg::PostNcDestroy() 
{
 delete this;remextdlg=0;
}
//-----------------------------------------------------------------------------
int RemExtDlg::GetCOMAnswer(int retexp)
{
 int res;

 COM_IsPolling=1;
 VDelay(IRadio_IB_CmdDel);//Give Radio some ms to respond
 res=comport.AskCOM_SPEC(retexp);
 if (res == retexp) 
  {
   //NBeep();
   return 1;
  } else return 0;
}
//-----------------------------------------------------------------------------
void RemExtDlg::OnANT() 
{
 ANTsw++;if (ANTsw > 1) ANTsw=0;
 comport.SwitchANT(ANTsw);GetCOMAnswer(IB_OK);
 remdisp->UpdateStatusDisp(0,0,1);	
}

void RemExtDlg::OnATT() 
{
 ATTsw++;if (ATTsw > 3) ATTsw=0;
 comport.SwitchATT(ATTsw);GetCOMAnswer(IB_OK);
 remdisp->UpdateStatusDisp(0,0,1);	
}

void RemExtDlg::OnPAMP() 
{
 PAMPsw++;if (PAMPsw > 2) PAMPsw=0;
 comport.SwitchPAMP(PAMPsw);GetCOMAnswer(IB_OK);
 remdisp->UpdateStatusDisp(0,0,1);
}

void RemExtDlg::OnAGC() 
{
 AGCsw++;if (AGCsw > 3) AGCsw=0;
 comport.SwitchAGC(AGCsw);GetCOMAnswer(IB_OK);
 remdisp->UpdateStatusDisp(0,0,1);	
}

void RemExtDlg::OnANF() 
{
 ANFsw++;if (ANFsw > 1) ANFsw=0;
 comport.SwitchANF(ANFsw);GetCOMAnswer(IB_OK);
 remdisp->UpdateStatusDisp(0,0,1);	
}

void RemExtDlg::OnNB() 
{
 NBsw++;if (NBsw > 1) NBsw=0;
 if (NBsw == 1) 
  {
   pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NB_LEV);
   pSB->SetFocus();
  }
 comport.SwitchNB(NBsw);GetCOMAnswer(IB_OK);
 remdisp->UpdateStatusDisp(0,0,1);	
}

void RemExtDlg::OnNR() 
{
 NRsw++;if (NRsw > 1) NRsw=0;
 if (NRsw == 1) 
  {
   pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NR_LEV);
   pSB->SetFocus();
  }
 comport.SwitchNR(NRsw);GetCOMAnswer(IB_OK);
 remdisp->UpdateStatusDisp(0,0,1);
}

void RemExtDlg::OnDUP() 
{
 DUPsw++;if (DUPsw > 2) DUPsw=0;
 comport.SwitchDUP(DUPsw);GetCOMAnswer(IB_OK);
 remdisp->UpdateStatusDisp(1,0,0);		
}

void RemExtDlg::OnRTTY()
{
 RTTY_Dlg rttydlg(this);
 
 RTTY_MFsw_n=2;
 comport.AskRTTY_MF();GetCOMAnswer(0x1A);
 rttydlg.m_MF=RTTY_MFsw_n;

 RTTY_SHsw_n=0;
 comport.AskRTTY_SH();GetCOMAnswer(0x1A);
 rttydlg.m_SH=RTTY_SHsw_n;

 RTTY_KPsw_n=0;
 comport.AskRTTY_KP();GetCOMAnswer(0x1A);
 rttydlg.m_KP=RTTY_KPsw_n;

 RTTY_RXDECsw_n=0;
 comport.AskRTTY_RXDEC();GetCOMAnswer(0x1A);
 rttydlg.m_RXDEC=RTTY_RXDECsw_n;
 
 RTTY_TPFsw_n=0;
 comport.AskRTTY_TPF();GetCOMAnswer(0x1A);
 rttydlg.m_TPF=RTTY_TPFsw_n;

 if (rttydlg.DoModal()==IDOK) 
  {
   RTTY_MFsw_n=rttydlg.m_MF;
   comport.SetRTTY_MF(RTTY_MFsw_n);GetCOMAnswer(IB_OK);

   RTTY_SHsw_n=rttydlg.m_SH;
   comport.SetRTTY_SH(RTTY_SHsw_n);GetCOMAnswer(IB_OK);

   RTTY_KPsw_n=rttydlg.m_KP;
   comport.SetRTTY_KP(RTTY_KPsw_n);GetCOMAnswer(IB_OK);

   RTTY_RXDECsw_n=rttydlg.m_RXDEC;
   comport.SetRTTY_RXDEC(RTTY_RXDECsw_n);GetCOMAnswer(IB_OK);
   
   RTTY_TPFsw_n=rttydlg.m_TPF;
   comport.SetRTTY_TPF(RTTY_TPFsw_n);GetCOMAnswer(IB_OK);
  }
}
//-----------------------------------------------------------------------------
void RemExtDlg::OnAskAll()
{
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_AF);
 comport.AskAF_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(AFlev_n);
   
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_RF);
 comport.AskRF_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(RFlev_n);
  
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_SQL);
 comport.AskSQL_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(SQLlev_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_TXPWR);
 comport.AskTXPWR();GetCOMAnswer(0x14);
 pSB->SetScrollPos(TXPWR_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_CWSPEED);
 comport.AskCWSPEED();GetCOMAnswer(0x14);
 pSB->SetScrollPos(CWSPEED_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NR_LEV);
 comport.AskNR_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(NRlev_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NB_LEV);
 comport.AskNB_lev();GetCOMAnswer(0x14);
 pSB->SetScrollPos(NBlev_n);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NB_WID);
 comport.AskNB_wid();GetCOMAnswer(0x1A);
 pSB->SetScrollPos(NBwid_n);
    
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_PBTL);
 comport.AskPBTL();GetCOMAnswer(0x14);
 pSB->SetScrollPos(PBTL_n);
    
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_PBTH);
 comport.AskPBTH();GetCOMAnswer(0x14);
 pSB->SetScrollPos(PBTH_n);
 //-----------------------
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_AF);
 pSB->SetFocus();
}

void RemExtDlg::OnNeutral() 
{
 ATTsw=0;
 comport.SwitchATT(ATTsw);GetCOMAnswer(IB_OK);

 PAMPsw=0;
 comport.SwitchPAMP(PAMPsw);GetCOMAnswer(IB_OK);

 ANFsw=0;
 comport.SwitchANF(ANFsw);GetCOMAnswer(IB_OK);
 
 DUPsw=0;
 comport.SwitchDUP(DUPsw);GetCOMAnswer(IB_OK);
 
 /*pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_AF);
 AFlev_n=0;pSB->SetScrollPos(AFlev_n);
 comport.SetAF_lev(AFlev_n);GetCOMAnswer(IB_OK);*/

 NBsw=0;
 comport.SwitchNB(NBsw);
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NB_LEV);
 NBlev_n=128;/*Default=50%*/pSB->SetScrollPos(NBlev_n);
 comport.SetNB_lev(NBlev_n);GetCOMAnswer(IB_OK);
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NB_WID);
 NBwid_n=128;/*Default=50%*/pSB->SetScrollPos(NBwid_n);
 comport.SetNB_wid(NBwid_n);GetCOMAnswer(IB_OK);

 NRsw=0;
 comport.SwitchNR(NRsw);
 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NR_LEV);
 NRlev_n=72;/*Default=4*/pSB->SetScrollPos(NRlev_n);
 comport.SetNR_lev(NRlev_n);GetCOMAnswer(IB_OK);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_PBTL);
 PBTL_n=128;pSB->SetScrollPos(PBTL_n);
 comport.SetPBTL_lev(PBTL_n);GetCOMAnswer(IB_OK);

 pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_PBTH);
 PBTH_n=128;pSB->SetScrollPos(PBTH_n);
 comport.SetPBTH_lev(PBTH_n);GetCOMAnswer(IB_OK);

 RTTY_MFsw_n=2;
 comport.SetRTTY_MF(RTTY_MFsw_n);GetCOMAnswer(IB_OK);

 RTTY_SHsw_n=0;
 comport.SetRTTY_SH(RTTY_SHsw_n);GetCOMAnswer(IB_OK);

 RTTY_KPsw_n=0;
 comport.SetRTTY_KP(RTTY_KPsw_n);GetCOMAnswer(IB_OK);

 RTTY_RXDECsw_n=0;
 comport.SetRTTY_RXDEC(RTTY_RXDECsw_n);GetCOMAnswer(IB_OK);
 
 RTTY_TPFsw_n=0;
 comport.SetRTTY_TPF(RTTY_TPFsw_n);GetCOMAnswer(IB_OK);

 remdisp->UpdateStatusDisp(1,1,1);		
}
//-----------------------------------------------------------------------------
void RemExtDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
 int scr=0,pos=0;

 if (nSBCode > 9) return;

 switch (pScrollBar->GetDlgCtrlID())
  {
   case IDC_REMEXT_SCR_AF     :scr=0;pos=pScrollBar->GetScrollPos();break;
   case IDC_REMEXT_SCR_RF     :scr=1;pos=pScrollBar->GetScrollPos();break;
   case IDC_REMEXT_SCR_SQL    :scr=2;pos=pScrollBar->GetScrollPos();break;
   case IDC_REMEXT_SCR_PBTL   :scr=3;pos=pScrollBar->GetScrollPos();break;
   case IDC_REMEXT_SCR_PBTH   :scr=4;pos=pScrollBar->GetScrollPos();break;
   case IDC_REMEXT_SCR_NR_LEV :scr=5;pos=pScrollBar->GetScrollPos();break;
   case IDC_REMEXT_SCR_TXPWR  :scr=6;pos=pScrollBar->GetScrollPos();break;
   case IDC_REMEXT_SCR_CWSPEED:scr=7;pos=pScrollBar->GetScrollPos();break;
   case IDC_REMEXT_SCR_NB_LEV :scr=8;pos=pScrollBar->GetScrollPos();break;
   case IDC_REMEXT_SCR_NB_WID :scr=9;pos=pScrollBar->GetScrollPos();break;
  }

 switch (nSBCode) 
  {
   case SB_PAGEUP       :pos+=10;if (pos > 255) pos=255;break;//Bild nach oben
   case SB_PAGEDOWN     :pos-=10;if (pos <   0) pos=0  ;break;//Bild nach unten
        
   case SB_LINELEFT     :pos--;if (pos <   0) pos=0  ;break;  //<-
   case SB_LINERIGHT    :pos++;if (pos > 255) pos=255;break;  //->
   case SB_LEFT         :pos=0;break;                         //Pos1
   case SB_RIGHT        :pos=255;break;                       //End   
   case SB_THUMBPOSITION: 
   case SB_THUMBTRACK   :pos=nPos;break;
  }
   
 switch (scr) 
  {     
   case 0:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_AF);
          AFlev_n=pos;pSB->SetScrollPos(AFlev_n);
          comport.SetAF_lev(AFlev_n);GetCOMAnswer(IB_OK);
          break;
   case 1:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_RF);
          RFlev_n=pos;pSB->SetScrollPos(RFlev_n);
          comport.SetRF_lev(RFlev_n);GetCOMAnswer(IB_OK);
          break;
   case 2:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_SQL);
          SQLlev_n=pos;pSB->SetScrollPos(SQLlev_n);
          comport.SetSQL_lev(SQLlev_n);GetCOMAnswer(IB_OK);
          break;
   case 3:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_PBTL);
          PBTL_n=pos;pSB->SetScrollPos(PBTL_n);
          comport.SetPBTL_lev(PBTL_n);GetCOMAnswer(IB_OK);
          break;
   case 4:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_PBTH);
          PBTH_n=pos;pSB->SetScrollPos(PBTH_n);
          comport.SetPBTH_lev(PBTH_n);GetCOMAnswer(IB_OK);
          break;
   case 5:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NR_LEV);
          NRlev_n=pos;pSB->SetScrollPos(NRlev_n);
          comport.SetNR_lev(NRlev_n);GetCOMAnswer(IB_OK);        
          break;
   case 6:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_TXPWR);
          TXPWR_n=pos;pSB->SetScrollPos(TXPWR_n);
          comport.SetTXPWR(TXPWR_n);GetCOMAnswer(IB_OK);
          break;
   case 7:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_CWSPEED);
          CWSPEED_n=pos;pSB->SetScrollPos(CWSPEED_n);
          comport.SetCWSPEED(CWSPEED_n);GetCOMAnswer(IB_OK);
          break;
   case 8:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NB_LEV);
          NBlev_n=pos;pSB->SetScrollPos(NBlev_n);
          comport.SetNB_lev(NBlev_n);GetCOMAnswer(IB_OK);        
          break;
   case 9:pSB=(CScrollBar*) GetDlgItem(IDC_REMEXT_SCR_NB_WID);
          NBwid_n=pos;pSB->SetScrollPos(NBwid_n);
          comport.SetNB_wid(NBwid_n);GetCOMAnswer(IB_OK);        
          break;
  }		
 CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//RemDlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RemDlg::RemDlg(CWnd* pParent /*=NULL*/)
	   : CDialog(RemDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(RemDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void RemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(RemDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(RemDlg, CDialog)
	//{{AFX_MSG_MAP(RemDlg)
    ON_BN_CLICKED(IDC_REM_ASK_SandSQL,  OnASK_SandSQL)
	ON_BN_CLICKED(IDC_REM_EXT,          OnEXTENDED)
	ON_BN_CLICKED(IDC_REM_LOG,          OnLOG)
	ON_BN_CLICKED(IDC_REM_MEM,          OnMEM)
	ON_BN_CLICKED(IDC_REM_SET_F,        OnSET_F)
	ON_BN_CLICKED(IDC_REM_SET_LAST,     OnSET_LAST)
	ON_BN_CLICKED(IDC_REM_SET_FOFFSET,  OnSET_FOFFSET)
	ON_BN_CLICKED(IDC_REM_SET_MODE,     OnSET_MODE)
	ON_BN_CLICKED(IDC_REM_HOWTO,        OnHOWTO)
	ON_BN_CLICKED(IDC_REM_ASK_FandM,    OnASK_FandM)
	ON_BN_CLICKED(IDC_REM_SET_FSTEP_HW, OnSET_FSTEP_HW)
	ON_BN_CLICKED(IDC_REM_SET_FSTEP_SW, OnSET_FSTEP_SW)
    ON_BN_CLICKED(IDC_REM_SET_VFO_AB,   OnSET_VFO_AB)
    ON_BN_CLICKED(IDC_REM_SET_VFOMEM,   OnSET_VFOMEM)
    ON_BN_CLICKED(IDC_REM_TUNE,         OnTUNE) 
    ON_MESSAGE(WM_REMWIN_ITEMSELECTION, OnMemSel)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP    
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL RemDlg::OnInitDialog() 
{
 LPCTSTR REMDISP;
 CString str("",50);
 char    tmpstr[10];

 CDialog::OnInitDialog();

 m_hAccel=NULL;
 m_hAccel=LoadAccelerators(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_REMACCEL));
 SetIcon(::LoadIcon(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME)),TRUE);

 itoa(Radio_Num+1,tmpstr,10);
 str="REMOTE (RADIO ";str+=tmpstr;str+=")";
 SetWindowText(str);
  
 remdisp=new RemDisp();
 REMDISP=AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW,
	                         LoadCursor(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDC_CURSOR_REMO)),
		                     (HBRUSH)(COLOR_WINDOW+1),
			                 NULL);
 remdisp->Create(REMDISP,"DISPLAY",0,CFrameWnd::rectDefault,AfxGetApp()->GetMainWnd(),0,NULL);
 remdisp->SetIcon(::LoadIcon(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME)),TRUE);
          
 comport.Open(COM_PORT,COM_BAUD,COM_DATA,COM_STOP,COM_PARI,COM_PROT,1000,1000);
 //Initialisierungen------
 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {
   RadioSettings();
   strcpy(Fdef_s,IRADIO_IB[Radio_Num].Fdef_s);ModFstr(Fdef_s,Fdef_s);
   strcpy(Fact_s,IRADIO_IB[Radio_Num].RE_Fact_s);ModFstr(Fact_s,Fdef_s);Fact_n=FstrToFnum(Fact_s); 
   ModFstr(IRADIO_IB[Radio_Num].Fmin_s,Fdef_s);Fmin_n=FstrToFnum(IRADIO_IB[Radio_Num].Fmin_s);
   ModFstr(IRADIO_IB[Radio_Num].Fmax_s,Fdef_s);Fmax_n=FstrToFnum(IRADIO_IB[Radio_Num].Fmax_s);
   strcpy(SFact_s,IRADIO_IB[Radio_Num].RE_SFact_s);ModFstr(SFact_s,SFdef_s);SFact_n=FstrToFnum(SFact_s);
   strcpy(OFact_s,IRADIO_IB[Radio_Num].RE_OFact_s);ModFstr(OFact_s,OFdef_s);OFact_n=FstrToFnum(OFact_s);
   Mact_n=IRADIO_IB[Radio_Num].RE_Mact_n;MnumToMstr(Mact_n,Mact_s);
   FIact_n=IRADIO_IB[Radio_Num].RE_FIact_n;FInumToFIstr(FIact_n,FIact_s);
   SetActToLast();
   strcpy(SMlev_s,"0");RSMCFile(IRADIO_IB[Radio_Num].SmConv_s);
  }
 //Ende Initialisierungen-
 REMO=1;
 if (COM_Poll_Mode == 1) SetCOMTimer();
 IdleCount=0;   
 
 GetDlgItem(IDC_REM_ASK_FandM)->SetFocus();
 OnASK_FandM();VDelay(IRadio_IB_CmdDel);OnASK_SandSQL();
 remdisp->Invalidate();
	
 return FALSE;// return TRUE unless you set the focus to a control
}
//-----------------------------------------------------------------------------
BOOL RemDlg::PreTranslateMessage(MSG* pMsg) 
{
 if(!(m_hAccel && ::TranslateAccelerator(m_hWnd, m_hAccel, pMsg)))
   return CDialog::PreTranslateMessage(pMsg);else return TRUE;
	
 return CDialog::PreTranslateMessage(pMsg);
}
//-----------------------------------------------------------------------------
void RemDlg::OnOK() 
{
 PtrToRemDisp=NULL;
 remdisp->DestroyWindow();remdisp=0;
 if (remwin != 0) {remwin->DestroyWindow();remwin=0;}
 if (COM_Poll_Mode == 1) KillCOMTimer();
 IdleCount=0;   
 DestroyWindow();
}

void RemDlg::PostNcDestroy() 
{
 REMO=0;

 if (remwin    != 0) {remwin->DestroyWindow();remwin=0;}
 if (remextdlg != 0) {remextdlg->DestroyWindow();remextdlg=0;}

 comport.ClrRXBuf();comport.ClrTXBuf();
 comport.Close();
 //Deinitialisierungen------
 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {
   strcpy(IRADIO_IB[Radio_Num].RE_Fact_s,Fact_s);
   strcpy(IRADIO_IB[Radio_Num].RE_SFact_s,SFact_s);
   strcpy(IRADIO_IB[Radio_Num].RE_OFact_s,OFact_s);
   IRADIO_IB[Radio_Num].RE_Mact_n=Mact_n;
   IRADIO_IB[Radio_Num].RE_FIact_n=FIact_n; 
  }
 //Ende Deinitialisierungen-
 delete this;
 remdlg=0; 
}
//-----------------------------------------------------------------------------
int RemDlg::GetCOMAnswer(int retexp)
{
 int res;

 COM_IsPolling=1;
 VDelay(IRadio_IB_CmdDel);//Give Radio some ms to respond
 res=comport.AskCOM_SPEC(retexp);
 if (res == retexp) 
  {
   //NBeep();
   return 1;
  } else return 0;
}
//-----------------------------------------------------------------------------
void RemDlg::OnSET_F() 
{
 char         instr[RStrLf];
 int          res,limit=12; 
 unsigned int y;

 strcpy(instr,Fact_s);
 res=MyInpDlg(this,AppName,"Enter Frequency","",instr,limit);
 if (res == IDCANCEL) return;
 //-----------------------------
 ModFstr(instr,Fdef_s);y=FstrToFnum(instr);
 if (y < Fmin_n || y > Fmax_n) return;
 //-----------------------------
 SetActToLast();
 strcpy(Fact_s,instr);ModFstr(Fact_s,Fdef_s);Fact_n=FstrToFnum(Fact_s);
 comport.SetFREQ(Fact_s);res=GetCOMAnswer(IB_OK);
 if (res) {remdisp->UpdateFreqDisp();remdisp->UpdateStatusDisp(1,1,0);}
}

void RemDlg::OnSET_LAST() 
{
 int res;

 strcpy(Fact_s,Flas_s);
 Fact_n=FstrToFnum(Fact_s);
 comport.SetFREQ(Fact_s);res=GetCOMAnswer(IB_OK);
 if (res) remdisp->UpdateFreqDisp();

 strcpy(Mact_s,MOs[Mlas_n]);Mact_n=Mlas_n;
 strcpy(FIact_s,FIs[FIlas_n]);FIact_n=FIlas_n; 
 comport.SetMODE(Mact_n,FIact_n);res=GetCOMAnswer(IB_OK);
 if (res) remdisp->UpdateStatusDisp(1,1,0);	
}

void RemDlg::OnSET_MODE() 
{
 int res;

 MODE_Dlg modedlg(this);
 SetActToLast();
 modedlg.m_mode=Mact_n;
 modedlg.m_filter=FIact_n; 
 if (modedlg.DoModal()==IDOK) 
  {
   Mact_n=modedlg.m_mode;strcpy(Mact_s,MOs[Mact_n]);
   FIact_n=modedlg.m_filter;strcpy(FIact_s,FIs[FIact_n]);
   comport.SetMODE(Mact_n,FIact_n);res=GetCOMAnswer(IB_OK);
   if (res) remdisp->UpdateStatusDisp(1,0,0);
  }
}

void RemDlg::OnSET_FSTEP_SW()//SW-Tuning-Steps  
{
 CString dstr("",RStrLf);
 int     res;
 char    actstr[RStrLf],str_tmp[RStrLf];

 strcpy(actstr,SFact_s);StrTrLe(actstr,' ');dstr=actstr;
 FSTEPSW_Dlg fstepswdlg(this);
 fstepswdlg.m_Combo=actstr;UpdateData(TRUE);
 if (fstepswdlg.DoModal()==IDOK) 
  {
   UpdateData(FALSE);
   if (fstepswdlg.m_Combo != "")
    {
     strcpy(SFact_s,LPCTSTR(fstepswdlg.m_Combo));
     ModFstr(SFact_s,SFdef_s);SFact_n=FstrToFnum(SFact_s);
     remdisp->UpdateStatusDisp(0,1,0);
     //Auch HW(Radio) umschalten-------------------------
     strcpy(str_tmp,SFact_s);
     ModFstr(str_tmp,".001");StrTrLe(str_tmp,' ');
     comport.SetTuStep(SFstrToSFind(str_tmp));res=GetCOMAnswer(IB_OK);
    }
  }	
}

void RemDlg::OnSET_FSTEP_HW()//HW-Tuning-Steps 
{
 FSTEPHW_Dlg fstephwdlg(this);
 if (fstephwdlg.DoModal()==IDOK)
  {
   UpdateData(FALSE);
   comport.SetTuStep(fstephwdlg.m_list);GetCOMAnswer(IB_OK);
  }
}

void RemDlg::OnSET_FOFFSET() 
{
 CString    dstr("",RStrLf);
 char       actstr[RStrLf];

 strcpy(actstr,OFact_s);StrTrLe(actstr,' ');dstr=actstr;
 FOFFSET_Dlg foffsetdlg(this);
 foffsetdlg.m_Combo=actstr;UpdateData(TRUE);
 if (foffsetdlg.DoModal()==IDOK)
  {
   UpdateData(FALSE);
   if (foffsetdlg.m_Combo != "")
    {
     strcpy(OFact_s,LPCTSTR(foffsetdlg.m_Combo));
     ModFstr(OFact_s,OFdef_s);OFact_n=FstrToFnum(OFact_s);
     remdisp->UpdateStatusDisp(0,1,0);
    }
  }		
}
//-----------------------------------------------------------------------------
void RemDlg::OnSET_VFO_AB()
{
 VFOsw++;if (VFOsw > 1) VFOsw=0;
 comport.SwitchVFO(VFOsw);GetCOMAnswer(IB_OK);
}

void RemDlg::OnSET_VFOMEM()
{
 VMsw++;if (VMsw > 1) VMsw=0;
 comport.SwitchVM(VMsw);GetCOMAnswer(IB_OK);
}
//-----------------------------------------------------------------------------
void RemDlg::OnTUNE()
{
 int  mode_org,pwr_org,res,limit=3;
 char instr  [  5]="27",
      msgstr1[100]="Radio will be switched to FM, set TX-PWR for tuning",
      msgstr2[100]="27=10W, 53=20W (0-255)",
      msgstr3[100]="Push PTT to transmit + tune\n"
                   "Press Enter to return to original TX-PWR + Mode";

 comport.ClrRXBuf();
 //Mode + Sendeleistung abfragen------
 comport.AskMODE();GetCOMAnswer(0x04);
 mode_org=Mact_n;
 comport.AskTXPWR();GetCOMAnswer(0x14);
 pwr_org=TXPWR_n;if (TXPWR_tune > 255) TXPWR_tune=255;
 //IntDeb(pwr_org,comport.RXb[8],comport.RXb[9],(TXPWR_tune*100)/255);
 itoa(TXPWR_tune,instr,10);
 res=MyInpDlg(this,AppName,msgstr1,msgstr2,instr,limit);
 if (res == IDOK)
  {
   TXPWR_tune=atoi(instr);if (TXPWR_tune > 255) TXPWR_tune=255;
   comport.SetMODE(2,FIact_n);GetCOMAnswer(IB_OK);//Mode FM=2
   comport.SetTXPWR(TXPWR_tune);GetCOMAnswer(IB_OK);VDelay(IRadio_IB_CmdDel);//27=10W, 53=20 W (0-255) 
   MyMsgBox(AppName,msgstr3,2);
   comport.SetMODE(mode_org,FIact_n);GetCOMAnswer(IB_OK);
   comport.SetTXPWR(pwr_org);GetCOMAnswer(IB_OK);
  }
 SetFocus();
}
//-----------------------------------------------------------------------------
void RemDlg::OnASK_FandM() 
{
 comport.AskFREQ();GetCOMAnswer(0x03); 
 comport.AskMODE();GetCOMAnswer(0x04);
 remdisp->UpdateFreqDisp();  
}

void RemDlg::OnASK_SandSQL() 
{
 if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
  {
   if (IRADIO_IB[Radio_Num].SQL_SH == 0) {comport.AskSQL_SW_oc();GetCOMAnswer(0x15);}
      else comport.AskSQL_HW_oc();
   comport.AskSM_lev();GetCOMAnswer(0x16);
   if (SM_sel) SetSMstr(SMlev_n,1);else SetSMstr(SMlev_n,0);
   remdisp->UpdateStatusDisp(1,0,0);  
  }
}
//-----------------------------------------------------------------------------
void RemDlg::OnLOG() 
{
 CStdioFile     F_Out;
 CFileException F_Exc;
 CString        str; 
 char           radStr[RStrLt],remStr[RStrLr],inStr[30]="";
 int            res,limit=29;

 res=MyInpDlg(this,AppName,"Enter Remark for Logbook","",inStr,limit);
 if (res == IDOK)
  {
   CombineRemStr(remStr,inStr);CombineRadStr(radStr,remStr);str=radStr;

   if(!F_Out.Open(F_Log,CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite | CFile::typeText,&F_Exc))
    {
     //MessageBox(0,"ERROR file (R_Rem:OnLOG)","",MB_ICONSTOP | MB_OK);
    }else
    {
     F_Out.SeekToEnd();
     F_Out.WriteString(str);//F_Out.WriteString("\n");
     F_Out.Close();
    }
  }	
}
//-----------------------------------------------------------------------------
LRESULT RemDlg::OnMemSel(WPARAM wParam,LPARAM lParam)
{
 char         tmpF[RStrLf],tmpM[RStrLm],str[RStrLt];
 unsigned int x;

 strcpy(str,LPCTSTR(remwin->LineBuf));
 //MyMsgBox(AppName,str,1);
 GetFM(tmpF,tmpM,str);
 if (ChCorrFstart(tmpF) == 0) return 0;
 ModFstr(tmpF,Fdef_s);
 x=FstrToFnum(tmpF);
 if (x < Fmin_n || x > Fmax_n) return 0;
 //-----------------------------
 SetActToLast();
 strcpy(Fact_s,tmpF);Fact_n=FstrToFnum(Fact_s);
 comport.SetFREQ(Fact_s);GetCOMAnswer(IB_OK);
 //-----------------------------
 GetAddRemData(str,0);                     //SF
 GetAddRemData(str,1);                     //OF
 GetAddRemData(str,2);                     //FI
 //-----------------------------
 GetAddRemData(str,3);                     //ATT
 comport.SwitchATT(ATTsw);GetCOMAnswer(IB_OK);
 //----------------------------- 
 GetAddRemData(str,4);                     //DUP
 comport.SwitchDUP(DUPsw);GetCOMAnswer(IB_OK);
 //-----------------------------
 GetAddRemData(str,5);                     //PAMP
 comport.SwitchPAMP(PAMPsw);GetCOMAnswer(IB_OK);
 //----------------------------- 
 ModMstr(tmpM);strcpy(Mact_s,MOs[Mact_n]);
 comport.SetMODE(Mact_n,FIact_n);GetCOMAnswer(IB_OK);
 //-----------------------------
 remdisp->UpdateFreqDisp();remdisp->UpdateStatusDisp(1,1,1);
 //HW-SF setzen----------------- 
 strcpy(tmpF,SFact_s);
 ModFstr(SFact_s,".001");StrTrLe(SFact_s,' ');
 comport.SetTuStep(SFstrToSFind(SFact_s));GetCOMAnswer(IB_OK);

 return 0L;
}

void RemDlg::OnMEM() 
{
 CFileDialog *OpenDlg;
 CRect       rect; 
 CString     FiName("",Fl); 
 char        file[Fl]="";

 if (remwin != 0) return;
 OpenDlg=new CFileDialog(TRUE,NULL,"",OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST, 
                         "Frequency-Files (*.FRE)|*.fre|All Files (*.*)|*.*||");
 OpenDlg->m_ofn.lpstrTitle="File Open";
 if (OpenDlg->DoModal()== IDOK)
  {
   FiName=OpenDlg->GetPathName();
  }else FiName="";
 delete OpenDlg;
 if (FiName == "") return;
 //-----------------------
 remwin=new RemWin((CFrameWnd*)this,FiName);
 remwin->Create(NULL,FiName,0,CFrameWnd::rectDefault,this,0,NULL);
 remwin->SetIcon(::LoadIcon(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME)),TRUE);
}

void RemDlg::OnHOWTO() 
{
 MyMsgBox(AppName,"ENTER FREQUENCIES:\n"
                  "MHz number(s)\n"
                  "point\t + optional (1-3) kHz number(s)\n"
                  "comma\t + optional (1-3) Hz number(s)\n\n"
                  "DISPLAY:\n"
                  "L./R. Mouseb. on digit\t: Down/Up 1\n"
                  "L./R. Mouseb. on  \t: F-Step Down/Up\n"
                  "Same functions available for Mousewheel\n\n"
                  "L. Mouseb. + CTRL on \t: F-Offset\n"
                  "R. Mouseb. + CTRL on \t: F+Offset\n\n"
                  "L. Mouseb. + SHIFT on digit\t: Digit=0\n\n"
                  "Arrow-keys\t\t: F-Step up/down\n"
                  "Pg Up/Down\t\t: F-Offset up/down",1);
 //comport.SendNOTOK();
 //comport.TestCmd(0);
  
}
//-----------------------------------------------------------------------------
void RemDlg::OnEXTENDED() 
{
 if (remextdlg != 0) return;
 remextdlg=new RemExtDlg(this);
 remextdlg->Create(IDD_REMEXTDLG,this);
 remextdlg->ShowWindow(SW_SHOW);
}
//-----------------------------------------------------------------------------
void RemDlg::SetCOMTimer()
{
 if (COM_Timer_ID != 0) KillCOMTimer();//Falls Timer inst., kill

 COM_Timer_ID=SetTimer(1,COM_Poll_Interval,NULL);		
 if (COM_Timer_ID == 0)//Kein Timer verf. 
  {
   MyMsgBox(AppName,"ERROR: COM-Timer",3);  
  }
}

void RemDlg::KillCOMTimer()
{
 if (COM_Timer_ID != 0) {KillTimer(COM_Timer_ID);COM_Timer_ID=0;}
}

void RemDlg::OnTimer(UINT nIDEvent) 
{
 int res;

 if (COM_Timer_ID != nIDEvent)//Anderer Timer
  {
   CDialog::OnTimer(nIDEvent);return;
  }
 if (REMO == 1 && COM_Poll_Mode == 1)//ONLY when COM-Polling=Intervals
  {
   if (COM_IsPolling == 0) 
    {
     res=comport.AskCOM_IDLE();
     IdleCount++;
     if (SQLSM_cont == 1 && IdleCount > 100 && COM_Poll_Interval > 9)
      {
       //NBeep();
       IdleCount=0;
       OnASK_SandSQL();
      }
    }
  }
	
 CDialog::OnTimer(nIDEvent);
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++















































